Files
apfstests/tests/generic/068
T
Zhihao Cheng b7cecbea22 fstests: Add path $here before src/<file>
Calling src/<file> without path '$here' may cause the problem that
the file cannot be found.

For example, Running generic/192 with overlayfs(Let ubifs as base
fs) yields the following output:

  generic/192 - output mismatch
     QA output created by 192
     sleep for 5 seconds
     test
    +./common/rc: line 316: src/t_dir_type: No such file or directory
     delta1 is in range
     delta2 is in range
    ...

When the use case fails, the call stack in generic/192 is:

  local unknowns=$(src/t_dir_type $dir u | wc -l)	common/rc
  _supports_filetype					common/rc
  _overlay_mount					common/overlay
  _overlay_test_mount					common/overlay
  _test_mount						common/rc
  _test_cycle_mount					generic/192

Before _test_cycle_mount() being invoked, generic/192 executed 'cd
/' to change work dir from 'xfstests-dev' to '/', so src/t_dir_type
was not found.

[Eryu: some tests run src/<file> as regular user, don't add $here
prefix in such case, as a regular user may have no search permission
on $here]

Signed-off-by: Zhihao Cheng <chengzhihao1@huawei.com>
Reviewed-by: Eryu Guan <guaneryu@gmail.com>
Signed-off-by: Eryu Guan <guaneryu@gmail.com>
2019-10-23 23:12:42 +08:00

117 lines
2.5 KiB
Bash
Executable File

#! /bin/bash
# SPDX-License-Identifier: GPL-2.0
# Copyright (c) 2000-2005 Silicon Graphics, Inc. All Rights Reserved.
#
# FSQA Test No. 068
#
# Test case to reproduce xfs_freeze hang under filsystem load.
# The fail case for this test is a hang on an xfs_freeze.
#
seq=`basename $0`
seqres=$RESULT_DIR/$seq
echo "QA output created by $seq"
here=`pwd`
tmp=/tmp/$$
status=0 # success is the default!
ITERATIONS=10
_cleanup()
{
cd /
trap 0 1 2 3 15
exit $status
}
trap "_cleanup" 0 1 2 3 15
# get standard environment, filters and checks
. ./common/rc
. ./common/filter
# real QA test starts here
_supported_fs generic
_supported_os Linux
_require_scratch
_require_freeze
echo "*** init FS"
rm -f $seqres.full
_scratch_unmount >/dev/null 2>&1
echo "*** MKFS ***" >>$seqres.full
echo "" >>$seqres.full
_scratch_mkfs >>$seqres.full 2>&1 \
|| _fail "mkfs failed"
_scratch_mount
touch $tmp.running
# start fsstress loop in a background block
{
STRESS_DIR="$SCRATCH_MNT/fsstress_test_dir"
mkdir "$STRESS_DIR"
procs=2
nops=200
while [ -f "$tmp.running" ]
do
# We do both read & write IO - not only is this more realistic,
# but it also potentially tests atime updates
FSSTRESS_ARGS=`_scale_fsstress_args -d $STRESS_DIR -p $procs -n $nops $FSSTRESS_AVOID`
$FSSTRESS_PROG $FSSTRESS_ARGS > /dev/null 2>&1
done
rm -r $STRESS_DIR/*
rmdir $STRESS_DIR
} &
# start fstest -m loop in a background block; this gets us mmap coverage
{
FSTEST_DIR="$SCRATCH_MNT/fstest_test_dir"
mkdir "$FSTEST_DIR"
procs=2
while [ -f "$tmp.running" ]
do
$here/src/fstest -m -p $FSTEST_DIR -n $procs -f 4 > /dev/null 2>&1
done
rm -rf $FSTEST_DIR/*
rmdir $FSTEST_DIR
} &
i=0
let ITERATIONS=$ITERATIONS-1
echo | tee -a $seqres.full
while [ $i -le $ITERATIONS ]
do
echo "*** iteration: $i" | tee -a $seqres.full
echo "*** freezing \$SCRATCH_MNT" | tee -a $seqres.full
xfs_freeze -f "$SCRATCH_MNT" | tee -a $seqres.full
[ $? != 0 ] && echo xfs_freeze -f "$SCRATCH_MNT" failed | \
tee -a $seqres.full
sleep 2
echo "*** thawing \$SCRATCH_MNT" | tee -a $seqres.full
xfs_freeze -u "$SCRATCH_MNT" | tee -a $seqres.full
[ $? != 0 ] && echo xfs_freeze -u "$SCRATCH_MNT" failed | \
tee -a $seqres.full
sleep 2
echo | tee -a $seqres.full
let i=$i+1
done
# stop fsstress iterations
rm $tmp.running
# wait for fsstresses to finish
wait
exit 1